local FOLDER_NAME, private = ...
local core = LibStub("AceAddon-3.0"):GetAddon(FOLDER_NAME)
local L = LibStub("AceLocale-3.0"):GetLocale(FOLDER_NAME)
local ACR = LibStub("AceConfigRegistry-3.0")
local version = GetAddOnMetadata(FOLDER_NAME, "X-Version")
local author = GetAddOnMetadata(FOLDER_NAME, "X-Author")
local builddate = GetAddOnMetadata(FOLDER_NAME, "X-Build")
local playerName = UnitName("player")
local pairs, type = pairs, type
local getOpt, setOpt

do
    function getOpt(info)
        local key = info[#info]
        return core.db.profile[key]
    end

    function setOpt(info, value)
        local key = info[#info]
        core.db.profile[key] = value
        core:applySettings()
    end
end

local BCMDropDownMenu = CreateFrame("Frame", "BCMDropDownMenu")
BCMDropDownMenu.displayMode = "MENU"
BCMDropDownMenu.info = {}
BCMDropDownMenu.uncheck = function(dropdownbutton)
    _G[dropdownbutton:GetName() .. "Check"]:Hide()
end

local info = {}
BCMDropDownMenu.initialize = function(self, level)
    if not level then return end
    local info = self.info
    wipe(info)
    if level == 1 then
        info.keepShownOnClick = 1
        info.isTitle = 1
        info.text = "Broker Elements"
        info.notCheckable = 1
        UIDropDownMenu_AddButton(info, level)
        info.isTitle = nil
        info.text = ""
        info.disabled = 1
        UIDropDownMenu_AddButton(info, level)
        info.isTitle = 1
        info.text = L["Tracking Options"]
        UIDropDownMenu_AddButton(info, level)
        info.isTitle = nil
        info.disabled = nil
        info.hasArrow = 1
        info.text = ("|cff00ff00" .. L["The Burning Crusade"] .. "|r")
        info.value = "submenu1"
        info.func = self.uncheck
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cff0066ff" .. L["Wrath of the Lich King"] .. "|r")
        info.value = "submenu2"
        info.func = self.uncheck
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cffff6600" .. L["Cataclysm"] .. "|r")
        info.value = "submenu3"
        info.func = self.uncheck
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cff19ac87" .. L["Mists of Pandaria"] .. "|r")
        info.value = "submenu4"
        info.func = self.uncheck
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cfffd482f" .. L["Warlords of Draenor"] .. "|r")
        info.value = "submenu5"
        info.func = self.uncheck
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cff299f06" .. L["Legion"] .. "|r")
        info.value = "submenu6"
        info.func = self.uncheck
        UIDropDownMenu_AddButton(info, level)
        info.hasArrow = nil
        info.notCheckable = nil
        info.text = L["Show icons on the tracker."]
        info.func = function() core.db.profile.showIcons = not core.db.profile.showIcons CloseDropDownMenus() core:applySettings() ToggleDropDownMenu(1, nil, BCMDropDownMenu, private.fname, 0, 0) end
        info.checked = function() return core.db.profile.showIcons end
        UIDropDownMenu_AddButton(info, level)
        if core.db.profile.showIcons then
            info.text = L["Show icons only on the tracker."]
            info.func = function() core.db.profile.iconsOnly = not core.db.profile.iconsOnly CloseDropDownMenus() core:applySettings() ToggleDropDownMenu(1, nil, BCMDropDownMenu, private.fname, 0, 0) end
            info.checked = function() return core.db.profile.iconsOnly end
            UIDropDownMenu_AddButton(info, level)
        end
        if not core.db.profile.iconsOnly or not core.db.profile.showIcons then
            info.text = L["Show short text on the tracker."]
            info.func = function() core.db.profile.showShort = not core.db.profile.showShort core:applySettings() end
            info.checked = function() return core.db.profile.showShort end
            UIDropDownMenu_AddButton(info, level)
        end
        info.notCheckable = 1
        info.text = ""
        info.disabled = 1
        UIDropDownMenu_AddButton(info, level)
        info.isTitle = 1
        info.text = L["Tooltip Options"]
        UIDropDownMenu_AddButton(info, level)
        info.isTitle = nil
        info.notCheckable = nil
        info.disabled = nil
        info.text = ("|cff00ff00" .. L["The Burning Crusade"] .. "|r")
        info.func = function() core.db.profile.modules.cmbc = not core.db.profile.modules.cmbc core:applySettings() end
        info.checked = function() return core.db.profile.modules.cmbc end
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cff0066ff" .. L["Wrath of the Lich King"] .. "|r")
        info.func = function() core.db.profile.modules.cmlk = not core.db.profile.modules.cmlk core:applySettings() end
        info.checked = function() return core.db.profile.modules.cmlk end
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cffff6600" .. L["Cataclysm"] .. "|r")
        info.func = function() core.db.profile.modules.cmcata = not core.db.profile.modules.cmcata core:applySettings() end
        info.checked = function() return core.db.profile.modules.cmcata end
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cff19ac87" .. L["Mists of Pandaria"] .. "|r")
        info.func = function() core.db.profile.modules.cmmop = not core.db.profile.modules.cmmop core:applySettings() end
        info.checked = function() return core.db.profile.modules.cmmop end
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cfffd482f" .. L["Warlords of Draenor"] .. "|r")
        info.func = function() core.db.profile.modules.cmwod = not core.db.profile.modules.cmwod core:applySettings() end
        info.checked = function() return core.db.profile.modules.cmwod end
        UIDropDownMenu_AddButton(info, level)
        info.text = ("|cff299f06" .. L["Legion"] .. "|r")
        info.func = function() core.db.profile.modules.cmleg = not core.db.profile.modules.cmleg core:applySettings() end
        info.checked = function() return core.db.profile.modules.cmleg end
        UIDropDownMenu_AddButton(info, level)
        info.text = L["Show zero counts in the tooltip."]
        info.func = function() core.db.profile.showZero = not core.db.profile.showZero core:applySettings() end
        info.checked = function() return core.db.profile.showZero end
        UIDropDownMenu_AddButton(info, level)
        info.text = L["Show bank counts in the tooltip."]
        info.func = function() core.db.profile.showBank = not core.db.profile.showBank core:applySettings() end
        info.checked = function() return core.db.profile.showBank end
        UIDropDownMenu_AddButton(info, level)
        info.text = L["Show alt counts in the tooltip."]
        info.func = function() core.db.profile.showAlts = not core.db.profile.showAlts core:applySettings() end
        info.checked = function() return core.db.profile.showAlts end
        UIDropDownMenu_AddButton(info, level)
        info.text = L["Show guild counts in the tooltip."]
        info.func = function() core.db.profile.showGuild = not core.db.profile.showGuild core:applySettings() end
        info.checked = function() return core.db.profile.showGuild end
        UIDropDownMenu_AddButton(info, level)
        info.text = L["Show totals in the tooltip."]
        info.func = function() core.db.profile.showTotal = not core.db.profile.showTotal core:applySettings() end
        info.checked = function() return core.db.profile.showTotal end
        UIDropDownMenu_AddButton(info, level)
        info.text = L["Show icons in the tooltip."]
        info.func = function() core.db.profile.tooltipIcons = not core.db.profile.tooltipIcons CloseDropDownMenus() core:applySettings() ToggleDropDownMenu(1, nil, BCMDropDownMenu, private.fname, 0, 0) end
        info.checked = function() return core.db.profile.tooltipIcons end
        UIDropDownMenu_AddButton(info, level)
        if core.db.profile.tooltipIcons then
            info.text = L["Show icons only in the tooltip."]
            info.func = function() core.db.profile.tooltipIconsOnly = not core.db.profile.tooltipIconsOnly CloseDropDownMenus() core:applySettings() ToggleDropDownMenu(1, nil, BCMDropDownMenu, private.fname, 0, 0) end
            info.checked = function() return core.db.profile.tooltipIconsOnly end
            UIDropDownMenu_AddButton(info, level)
        end
        if not core.db.profile.tooltipIconsOnly or not core.db.profile.tooltipIcons then
            info.text = L["Show short text in the tooltip."]
            info.func = function() core.db.profile.tooltipShowShort = not core.db.profile.tooltipShowShort core:applySettings() end
            info.checked = function() return core.db.profile.tooltipShowShort end
            UIDropDownMenu_AddButton(info, level)
        end
        info.text = L["Color lines in the tooltip."]
        info.func = function() core.db.profile.lineColor = not core.db.profile.lineColor core:applySettings() end
        info.checked = function() return core.db.profile.lineColor end
        UIDropDownMenu_AddButton(info, level)
        info.text = L["Color text in the tooltip."]
        info.func = function() core.db.profile.textColor = not core.db.profile.textColor core:applySettings() end
        info.checked = function() return core.db.profile.textColor end
        UIDropDownMenu_AddButton(info, level)
        info.notCheckable = 1
        info.text = ""
        info.disabled = 1
        UIDropDownMenu_AddButton(info, level)
        info.disabled = nil
        info.text = L["Close"]
        info.func = function() CloseDropDownMenus() end
        UIDropDownMenu_AddButton(info, level)
    elseif level == 2 then
        if UIDROPDOWNMENU_MENU_VALUE == "submenu1" then
            info.keepShownOnClick = 1
            for k, itemid in pairs(private.bcitems.id) do
                local color = private.bcitems.color[k]
                if not core.db.profile.textColor then color = "FFFFFF" end
                local name = private.bcitems.strings[k]
                local fixeditem = strsub(itemid, 1, -1)
                local item = "|cff" .. color .. name .. "|r"
                info.text = item
                info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
                info.checked = function() return core.db.profile.tracking[fixeditem] end
                UIDropDownMenu_AddButton(info, level)
            end
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu2" then
            info.keepShownOnClick = 1
            for k, itemid in pairs(private.lkitems.id) do
                local color = private.lkitems.color[k]
                if not core.db.profile.textColor then color = "FFFFFF" end
                local name = private.lkitems.strings[k]
                local fixeditem = strsub(itemid, 1, -1)
                local item = "|cff" .. color .. name .. "|r"
                info.text = item
                info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
                info.checked = function() return core.db.profile.tracking[fixeditem] end
                UIDropDownMenu_AddButton(info, level)
            end
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu3" then
            info.keepShownOnClick = 1
            for k, itemid in pairs(private.cataitems.id) do
                local color = private.cataitems.color[k]
                if not core.db.profile.textColor then color = "FFFFFF" end
                local name = private.cataitems.strings[k]
                local fixeditem = strsub(itemid, 1, -1)
                local item = "|cff" .. color .. name .. "|r"
                info.text = item
                info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
                info.checked = function() return core.db.profile.tracking[fixeditem] end
                UIDropDownMenu_AddButton(info, level)
            end
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu4" then
            info.keepShownOnClick = 1
            for k, itemid in pairs(private.mopitems.id) do
                local color = private.mopitems.color[k]
                if not core.db.profile.textColor then color = "FFFFFF" end
                local name = private.mopitems.strings[k]
                local fixeditem = strsub(itemid, 1, -1)
                local item = "|cff" .. color .. name .. "|r"
                info.text = item
                info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
                info.checked = function() return core.db.profile.tracking[fixeditem] end
                UIDropDownMenu_AddButton(info, level)
            end
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu5" then
            info.keepShownOnClick = 1
            for k, itemid in pairs(private.woditems.id) do
                local color = private.woditems.color[k]
                if not core.db.profile.textColor then color = "FFFFFF" end
                local name = private.woditems.strings[k]
                local fixeditem = strsub(itemid, 1, -1)
                local item = "|cff" .. color .. name .. "|r"
                info.text = item
                info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
                info.checked = function() return core.db.profile.tracking[fixeditem] end
                UIDropDownMenu_AddButton(info, level)
            end
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu6" then
            info.keepShownOnClick = 1
            for k, itemid in pairs(private.legitems.id) do
                local color = private.legitems.color[k]
                if not core.db.profile.textColor then color = "FFFFFF" end
                local name = private.legitems.strings[k]
                local fixeditem = strsub(itemid, 1, -1)
                local item = "|cff" .. color .. name .. "|r"
                info.text = item
                info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
                info.checked = function() return core.db.profile.tracking[fixeditem] end
                UIDropDownMenu_AddButton(info, level)
            end
        end
    end
end

local options, moduleOptions = nil, {}
local function getOptions()
    if not options then
        options = {
            type = "group",
            name = "Broker Elements",
            args = {
                display = {
                    order = 5,
                    type = "group",
                    inline = true,
                    name = "",
                    args = {
                        author = {
                            order = 10,
                            type = "description",
                            name = L["Author: "] .. author .. "    " .. L["Version: "] .. version .. "    " .. L["Build Date: "] .. builddate
                        },
                        counts = {
                            type = "group",
                            name = L["Display Options"],
                            guiInline = true,
                            order = 15,
                            get = getOpt,
                            set = setOpt,
                            args = {
                                showZero = {
                                    type = "toggle",
                                    order = 20,
                                    width = "full",
                                    name = L["Show zero counts in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                },
                                showBank = {
                                    type = "toggle",
                                    order = 25,
                                    width = "full",
                                    name = L["Show bank counts in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                },
                                showGuild = {
                                    type = "toggle",
                                    order = 30,
                                    width = "full",
                                    name = L["Show guild counts in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                },
                                showAlts = {
                                    type = "toggle",
                                    order = 35,
                                    width = "full",
                                    name = L["Show alt counts in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                },
                                showTotal = {
                                    type = "toggle",
                                    order = 37,
                                    width = "full",
                                    name = L["Show total count from all characters and sources in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                },
                            },
                        },
                        tooltip = {
                            type = "group",
                            name = L["Tooltip Options"],
                            guiInline = true,
                            order = 40,
                            get = getOpt,
                            set = setOpt,
                            args = {
                                scale = {
                                    order = 45,
                                    width = "full",
                                    type = "range",
                                    name = L["Scale"],
                                    min = .5,
                                    max = 1.5,
                                    step = .05,
                                    get = getOpt,
                                    set = setOpt,
                                },
                                scroll = {
                                    order = 50,
                                    width = "full",
                                    type = "range",
                                    name = L["Height"],
                                    min = 100,
                                    max = 900,
                                    step = 25,
                                    get = getOpt,
                                    set = setOpt,
                                },
                                tooltipIcons = {
                                    type = "toggle",
                                    order = 65,
                                    width = "full",
                                    name = L["Show icons in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                },
                                tooltipIconsOnly = {
                                    type = "toggle",
                                    order = 70,
                                    width = "full",
                                    name = L["Show icons only in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                    hidden = function() return not core.db.profile.tooltipIcons end
                                },
                                tooltipShowShort = {
                                    type = "toggle",
                                    order = 75,
                                    width = "full",
                                    name = L["Show short text in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                    hidden = function() if core.db.profile.tooltipIcons and core.db.profile.tooltipIconsOnly then return true end end
                                },
                                lineColor = {
                                    type = "toggle",
                                    order = 80,
                                    width = "full",
                                    name = L["Color lines in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                },
                                textColor = {
                                    type = "toggle",
                                    order = 85,
                                    width = "full",
                                    name = L["Color text in the tooltip."],
                                    get = getOpt,
                                    set = setOpt,
                                },
                            },
                        },
                        tracking = {
                            type = "group",
                            name = L["Tracking Options"],
                            guiInline = true,
                            order = 85,
                            get = getOpt,
                            set = setOpt,
                            args = {
                                showIcons = {
                                    type = "toggle",
                                    order = 90,
                                    width = "full",
                                    name = L["Show icons on the tracker."],
                                    get = getOpt,
                                    set = setOpt,
                                },
                                iconsOnly = {
                                    type = "toggle",
                                    order = 95,
                                    width = "full",
                                    name = L["Show icons only on the tracker."],
                                    get = getOpt,
                                    set = setOpt,
                                    hidden = function() return not core.db.profile.showIcons end
                                },
                                showShort = {
                                    type = "toggle",
                                    order = 100,
                                    width = "full",
                                    name = L["Show short text on the tracker."],
                                    get = getOpt,
                                    set = setOpt,
                                    hidden = function() if core.db.profile.showIcons and core.db.profile.iconsOnly then return true end end
                                },
                            },
                        },
                        purge = {
                            type = "group",
                            name = L["Delete Character"],
                            guiInline = true,
                            order = 105,
                            args = {
                                deleteChar = {
                                    type = "select",
                                    order = 110,
                                    name = L["Delete Character"],
                                    desc = L["This action will force a UI reload."],
                                    values = private.charsList,
                                    set = function(v, alt)
                                        core:purgeData(alt)
                                    end
                                },
                            },
                        },
                    },
                },
            },
        }
        for k, v in pairs(moduleOptions) do
            options.args[k] = (type(v) == "function") and v() or v
        end
    end
    return options
end

function core:SetupOptions()
    self.optFrames = {}
    ACR:RegisterOptionsTable(FOLDER_NAME, getOptions)
    self.optFrames.core = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(FOLDER_NAME, "Broker Elements", nil, "display")
    self.optFrames.core.default = function() core:SetDefaultOptions() end
    self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(core.db), "Profiles")
end

function core:SetDefaultOptions()
    core.db:ResetProfile()
    ACR:NotifyChange(FOLDER_NAME)
end

function core:RegisterModuleOptions(name, optTable, displayName)
    moduleOptions[name] = optTable
    self.optFrames[name] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(FOLDER_NAME, displayName or name, "Broker Elements", name)
end

function core:purgeData(alt)
    core.db.realm.chars[alt] = nil
    ReloadUI()
end
